import { action, computed, isAction, isComputedProp, isObservableProp, makeObservable, observable, } from 'mobx';
import { getDataMemberNames, getFacetMemberNames, getOperationMemberNames, } from 'skandha';
import { getAdmin } from '../internal/utils';
export const makeCtrObservable = (ctr) => {
    var _a;
    getFacetMemberNames(ctr).forEach((facetName) => {
        var _a;
        const facet = ctr[facetName];
        try {
            makeFacetObservable(facet);
        }
        catch (_b) { }
        ((_a = getAdmin(facet).effects) !== null && _a !== void 0 ? _a : []).forEach((f) => f());
    });
    try {
        makeObservable(ctr);
    }
    catch (_b) { }
    ((_a = getAdmin(ctr).effects) !== null && _a !== void 0 ? _a : []).forEach((f) => f());
};
export const makeFacetObservable = (facet) => {
    addActionsToFacet(facet);
    try {
        makeObservable(facet);
    }
    catch (_a) { }
    const observableMembers = {};
    getDataMemberNames(facet).forEach((dataMemberName) => {
        var _a;
        if (!isObservableProp(facet, dataMemberName) &&
            !isComputedProp(facet, dataMemberName)) {
            const descriptor = (_a = Object.getOwnPropertyDescriptor(facet, dataMemberName)) !== null && _a !== void 0 ? _a : Object.getOwnPropertyDescriptor(facet.constructor.prototype, dataMemberName);
            observableMembers[dataMemberName] =
                !descriptor || descriptor.get ? computed : observable;
        }
    });
    try {
        makeObservable(facet, observableMembers);
    }
    catch (_b) { }
};
const addActionsToFacet = (facet) => {
    getOperationMemberNames(facet).forEach((opName) => {
        if (!isAction(facet[opName])) {
            facet[opName] = action(facet[opName]);
        }
    });
};
export const onMakeCtrObservable = (ctr, f) => {
    var _a;
    const ctrAdmin = getAdmin(ctr);
    const effects = (ctrAdmin.effects = (_a = ctrAdmin.effects) !== null && _a !== void 0 ? _a : []);
    effects.push(f);
};
export const onMakeFacetObservable = (facet, f) => {
    var _a;
    const facetAdmin = getAdmin(facet);
    const effects = (facetAdmin.effects = (_a = facetAdmin.effects) !== null && _a !== void 0 ? _a : []);
    effects.push(f);
};
